import 'package:algolia/algolia.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:pc_plugins/controllers/suggestion/temp_config.dart';

import '../../custom_exception.dart';
import '../../model/algolia_filter_providers.dart';
import '../config_template.dart';

final suggestionLoadingPvd=AutoDisposeStateProviderFamily<bool,String>((ref, roles) => false);

class suggestionsController_temp<T> extends StateNotifier<List<T>>{
  final Reader reader;
  final String? myId;
  final sug_tempConfig<T> config;
  String lastSearch="";

  suggestionsController_temp(this.reader,this.myId,{required this.config}) : super([]);

  void setDialog(String s){
    if(config.dialogC!=null)
      reader(config.dialogC!.state).update((state) => s);
  }
  void setExDialog(CustomException e){
    if(config.exDialogC!=null)
      reader(config.exDialogC!.state).update((state) => e);
  }

  Future<void> search(String q,{int? lmt,List<String>? more=const []})async{
    lastSearch=q;
    if(reader(suggestionLoadingPvd(config.pageid)))return;
    reader(suggestionLoadingPvd(config.pageid).state).state=true;

    if(q.isEmpty){
      state=[];
      reader(suggestionLoadingPvd(config.pageid).state).state=false;
      return;
    }

    final filters=reader(algoFiltersPvd(config.pageid)).values.map((e) => e.function).toList();

    try{
      final snaps=config.customSearchFunc!=null?
      await config.customSearchFunc!(q,reader, page: 0,
          hperp: lmt??config.defaultPSize, containID: myId,filters: filters,
          attributes:config.attributesAlgo..addAll(more??[])):
      await reader(config.dataSrcPvd).searchT_algo(q,containID: myId,
          filters: filters, page: 0,hperp: lmt??config.defaultPSize,
          attributes:config.attributesAlgo..addAll(more??[]));
      reader(suggestionLoadingPvd(config.pageid).state).state=false;

      if(q==lastSearch){ state = snaps.data;}
      else{ search(lastSearch);}
    }on CustomException catch(e,st){
      reader(suggestionLoadingPvd(config.pageid).state).state=false;
      setExDialog(e);
    }
  }

  void dismiss(){
    reader(suggestionLoadingPvd(config.pageid).state).state=false;
    state.clear();
  }
}