
import 'package:pc_plugins/model/search_data/algo_param_helper.dart';

class searchData<T>{
  final List<T> data;
  final Map<String,dynamic> pageInfo;
  searchData({required this.data,Map<String,dynamic>? pageInfo})
  ///default value for timeout query
      :pageInfo=pageInfo??<String,dynamic>{"params":"","query":"","exhaustiveNbHits":false};

  searchData.single(T data):data=[data],
        pageInfo={"length":1,"nbHits":1,"nbPages":1,"page":0};

  AlgoParamHelper get paramHelper=>AlgoParamHelper(_params);
  List<String> getParams(List<String> excludes)=>paramHelper.excludeFilters(excludes);

  ///raw string params
  String get _params => pageInfo['params'];
  String? get queryID => pageInfo['queryID'];
  String get query => pageInfo['query'];

  int get hitsPerPage => pageInfo['hitsPerPage'] ?? 0;
  int get length => pageInfo['length'] ?? 0;
  int get nbHits => pageInfo['nbHits'] ?? 0;
  int get nbPages => pageInfo['nbPages'] ?? 0;
  int get offset => pageInfo['offset'] ?? 0;
  int get page => pageInfo['page'] ?? 0;

  Map<String, dynamic> get facets => pageInfo['facets'] ?? {};
  Map<String, dynamic> get facetsStats => pageInfo['facets_stats'] ?? {};

  bool get exhaustiveNbHits => pageInfo['exhaustiveNbHits'];
  int get processingTimeMS => pageInfo['processingTimeMS'] ?? 0;

  searchData<T> copyWith({List<T>? data,Map<String,dynamic>? pageInfo}){
    return searchData<T>(data: data??this.data,pageInfo: pageInfo??this.pageInfo);
  }
  searchData<T> add(T data){
    final pginfo=pageInfo..["nbHits"]=(nbHits+1);
    if(pageInfo['length']!=null)pginfo['length']=length+1;
    return searchData<T>(data: this.data..add(data),pageInfo: pginfo);
  }
  searchData<T> remove(int i){
    if(i==-1)return this;
    final pginfo=pageInfo..["nbHits"]=(nbHits-1);
    if(pageInfo['length']!=null)pginfo['length']=length-1;
    return searchData<T>(data: data..removeAt(i),pageInfo: pginfo);
  }

  bool get canPre=>page!=0;
  bool get canNext=>page!=nbPages-1;
}