import 'package:flutter/services.dart';

String unformatPhone(String n,{bool trim1=true}){
  n=n.replaceAll("+", "");
  n=n.replaceAll("-", "");
  n=n.replaceAll("(", "");
  n=n.replaceAll(")", "");
  if(trim1&&n.startsWith("1"))n=n.substring(1);
  return n;
}

String? phoneValidator(String? pn,{String invalid="invalid number!",bool cn=false,bool us=true}){
  if(pn==null)return invalid;
  final ppn=unformatPhone(pn,trim1: false);
  if(ppn.startsWith("1")){
    if((cn||us)&&ppn.length==11)return null;}
  else if(us&&ppn.length==10) {return null;}
  return invalid;
}

class PhoneFormatter extends TextInputFormatter {
  @override
  TextEditingValue formatEditUpdate(
      TextEditingValue oldValue, TextEditingValue newValue) {
    String phoneNumber=newValue.text;
    int s=newValue.selection.end;

    if(phoneNumber.startsWith('1')||phoneNumber.startsWith('+')){               //added fix for +1 phone numbers
      s++;
      if(phoneNumber.length>=10&&oldValue.text.length<10)s++;
      if(phoneNumber.length>=5&&oldValue.text.length<5)s+=2;
    }
    else{
      if(phoneNumber.length>=8&&oldValue.text.length<8)s++;
      if(phoneNumber.length>=3&&oldValue.text.length<3)s+=2;
    }
    // if(phoneNumber.length>9&&oldValue.text.length<9)s++;
    if (phoneNumber.contains("\(") && !phoneNumber.contains("\)")) {
      // Remove the digit the user wanted to remove but couldn't b/c a paren
      // was in the way.
      phoneNumber = phoneNumber.substring(0, phoneNumber.length - 1);
    }

    // Only store the actual digits
    phoneNumber = phoneNumber.replaceAll(RegExp("[^0-9]"), "");

    // Don't let the user enter more digits than is possible
    int maxLength = phoneNumber.startsWith("1") ? 11 : 10;
    if (phoneNumber.length > maxLength) {
      phoneNumber = phoneNumber.substring(0, maxLength);
      s--;
    }

    return newValue.copyWith(text: getFormattedPhoneNumber(phoneNumber),
        selection: TextSelection.collapsed(offset: s));
  }

  String getFormattedPhoneNumber(String _phoneNumber) {
    if (_phoneNumber.isEmpty) {
      return "";
    }

    String phoneNumber = _phoneNumber;
    bool addPlus = phoneNumber.startsWith("1");
    if (addPlus) phoneNumber = phoneNumber.substring(1);
    bool addParents = phoneNumber.length >= 3;
    bool addDash = phoneNumber.length >= 6;

    // +1
    String updatedNumber = "";
    if (addPlus) updatedNumber += "+1";

    // (222)
    if (addParents) {
      updatedNumber += "(";
      updatedNumber += phoneNumber.substring(0, 3);
      updatedNumber += ")";
    } else {
      updatedNumber += phoneNumber.substring(0);
      return updatedNumber;
    }

    // 111
    if (addDash) {
      updatedNumber += phoneNumber.substring(3, 6);
      updatedNumber += "-";
    } else {
      updatedNumber += phoneNumber.substring(3);
      return updatedNumber;
    }

    // 3333
    updatedNumber += phoneNumber.substring(6);
    return updatedNumber;
  }

}